<!-- 巡防力量 -->
<template>
  <div>
    <div class="titleBoxs">
      <div class="title">巡防力量</div>
      <div class="btnBox"></div>
    </div>
    <div class="content-box-sun">
      <!-- 组织机构盒子 -->
      <div class="org-box" :style="{ height: orgHeight + 'px' }">
        <div class="org-content-box">
          <div class="tree-box">
            <MOSTY.DepartmentTree
              width="100%"
              placeholder="管理部门ID"
              clearable
              filterable
              v-model="deptId"
            />
          </div>
        </div>
      </div>
      <div class="right-box-sun">
        <div class="chart-box">
          <pie :data="barData" />
        </div>
        <!-- 表格盒子 -->
        <div class="table-box">
          <!-- <div class="searchBox" ref="searchBox">
            <el-form :model="listQuery" :inline="true">
              <el-form-item label="根据时间查询">
                <el-date-picker
                  v-model="value1"
                  type="date"
                  placeholder="请选择"
                  :size="size"
                />
              </el-form-item>
              <el-form-item>
                <el-button @click="handleFilter"> 查询 </el-button>
                <el-button @click="reset()"> 重置 </el-button>
              </el-form-item>
            </el-form>
          </div> -->
          <div class="tabBox">
            <el-table
              :data="tableData"
              border
              row-key="id"
              style="width: 100%"
              :key="keyCount"
              :height="tableHeight"
              v-loading="loadingTable"
              element-loading-background="rgba(0,0,0,0.3)"
              element-loading-text="数据加载中。。"
              @selection-change="handleSelectionChange"
            >
              <el-table-column
                label="序号"
                type="index"
                align="center"
                width="60"
              />
              <el-table-column label="单位部门" prop="ssbm" align="center" />
              <el-table-column label="民警数量" prop="mj" align="center" />
              <el-table-column label="辅警数量" prop="fj" align="center" />
              <el-table-column label="警车数量" prop="car" align="center" />
              <!-- <el-table-column label="350M终端" prop="bz" align="center" />
              <el-table-column label="820终端" prop="bz" align="center" />
              <el-table-column label="移动警务通" prop="bz" align="center" /> -->
              <el-table-column
                label="操作"
                align="center"
                fixed="right"
                width="150px"
              >
                <template #default="{ row }">
                  <el-button @click="detail(row)" size="small">详情</el-button>
                </template>
              </el-table-column>
            </el-table>
            <div class="fenye" :style="{ top: tableHeight + 'px' }">
              <el-pagination
                class="pagination"
                @size-change="handleSizeChange"
                @current-change="handleCurrentChange"
                :current-page="listQuery.pageCurrent"
                :page-sizes="[10, 20, 50, 100]"
                :page-size="listQuery.pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="total"
              >
              </el-pagination>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="dialog" v-if="dialogFormVisible">
      <div class="head_box">
        <span class="title">{{ title }}</span>
        <div>
          <el-button size="small" @click="close">关闭</el-button>
        </div>
      </div>
      <el-form
        ref="elform"
        :model="form"
        :rules="rules"
        :inline="true"
        label-position="top"
        disabled
      >
        <el-form-item label="单位部门" prop="ssbm">
          <el-input v-model="form.ssbm"></el-input>
        </el-form-item>
        <el-form-item label="民警数量" prop="mj">
          <el-input v-model="form.mj"></el-input>
        </el-form-item>
        <el-form-item label="辅警数量" prop="fj">
          <el-input v-model="form.fj"></el-input>
        </el-form-item>
        <el-form-item label="警车数量" prop="car">
          <el-input v-model="form.car"></el-input>
        </el-form-item>
      </el-form>
    </div>
  </div>
</template>
<script setup>
import * as MOSTY from "@/components/MyComponents/index";
import pie from "./components/pie.vue";
import { selectDeptPage } from "@/api/user-manage";
import {
  getCarTj,
  getFjTj,
  getMjTj,
  getBarTj
} from "@/api/patrolStatistics/patrolForce.js";
import { getItem } from "@/utils/storage";
import { ref, watch, getCurrentInstance, onMounted, reactive } from "vue";
const { proxy } = getCurrentInstance();

const keyCount = ref(0); //tabel组件刷新值
const form = ref({}); //新增表单
const tableData = ref([]); //表格数据
const total = ref(0);
const chackAdd = ref(false); //新增修改切换
const loading = ref(false); //新增保存按钮截流
const ids = ref([]); //表格选中id集合
const searchBox = ref(null); //搜索盒子
const loadingTable = ref(true); //表格加载状态
const tableHeight = ref(); // 表格高度
const dialogFormVisible = ref(false);
const title = ref("新增"); //弹窗标题
const elform = ref(null); //新增表单容器
const deptId = ref(null);
const listQuery = ref({
  pageCurrent: 1,
  pageSize: 10
}); //搜索表单
watch(
  () => deptId.value,
  () => {
    getListData();
  }
);
//表单验证
const rules = ref({
  // name: [{ required: true, message: "请输入名称", trigger: "change" }]
});
// 部门树
const defaultProps = {
  children: "childDeptList",
  label: "orgName"
};
const orgList = ref([]);
const getSysMenuTree = () => {
  const params = {
    menuName: "",
    current: 1,
    size: 100
  };
  selectDeptPage(params).then((res) => {
    orgList.value = res.records;
  });
};
function handleNodeClick(val) {}
const barData = ref([]);
// 获取列表
function getListData() {
  try {
    const params = {
      ssbmdm: deptId.value,
      permissions: getItem("PermissionsInfo").permissionsSqlNoAlias
    };
    loadingTable.value = true;
    Promise.all([
      getCarTj(params),
      getFjTj(params),
      getMjTj(params),
      getBarTj(params)
    ]).then(([car, fj, mj, tj]) => {
      barData.value = [
        { sl: tj[0].fjsl, name: "辅警数量" },
        { sl: tj[0].mjsl, name: "民警数量" },
        { sl: tj[0].clsl, name: "警车数量" }
      ];
      var tabListArr = car.map((item) => item.ssbmdm);
      fj.forEach((v) => {
        if (tabListArr.indexOf(v.ssbmdm) == -1) {
          tabListArr.push(v.ssbmdm);
        }
      });
      mj.forEach((v) => {
        if (tabListArr.indexOf(v.ssbmdm) == -1) {
          tabListArr.push(v.ssbmdm);
        }
      });
      tableData.value = tabListArr.map((item) => {
        const fjObj = fj.filter((itemq) => item === itemq.ssbmdm);
        const mjObj = mj.filter((itemq) => item === itemq.ssbmdm);
        const carbj = car.filter((itemq) => item === itemq.ssbmdm);
        return {
          car: carbj && carbj.length > 0 ? carbj[0].sl : 0,
          mj: mjObj && mjObj.length > 0 ? mjObj[0].sl : 0,
          fj: fjObj && fjObj.length > 0 ? fjObj[0].sl : 0,
          ssbm: carbj
            ? carbj[0].ssbm
            : false || fjObj
            ? fjObj[0].ssbm
            : false || mjObj[0].ssbm
        };
      });
      total.value = tableData.value.length;
      loadingTable.value = false;
    });
  } catch (error) {
    loadingTable.value = false;
  }
}
//打开新增弹窗
function add() {
  chackAdd.value = true;
  dialogFormVisible.value = true;
}
//关闭弹窗
function close() {
  dialogFormVisible.value = false;
  form.value = {};
}
//提交
function submit() {
  elform.value.validate((valid) => {
    if (valid) {
      loading.value = true;
      setTimeout(() => {
        loading.value = false;
      }, 1500);
      if (chackAdd.value) {
        proxy.$message({
          type: "success",
          message: "新增成功"
        });
      } else {
        proxy.$message({
          type: "success",
          message: "修改成功"
        });
      }
    }
  });
}
//修改
function detail(row) {
  // API(row.id).then((res) => {
  //   form.value = res;
  // });
  chackAdd.value = false;
  form.value = row;
  title.value = "详情";
  dialogFormVisible.value = true;
}
//批量数据
const handleSelectionChange = (val) => {
  ids.value = [];
  if (val) {
    val.forEach((item) => {
      ids.value.push(item.id);
    });
  }
};
//删除
function delDictItem(row) {
  proxy
    .$confirm("确定要删除", "警告", {
      type: "warning"
    })
    .then(() => {
      // DELETE([row.id]).then(() => {
      //   proxy.$message({
      //     type: "success",
      //     message: "删除成功"
      //   });
      //   getListData();
      // });
    })
    .catch(() => {
      proxy.$message.info("已取消");
    });
}
//批量删除
function batchDelete() {
  proxy
    .$confirm("确定要删除", "警告", {
      type: "warning"
    })
    .then(() => {
      //       DELETE(ids.value).then((res) => {
      //         proxy.$message({
      //           message: "删除成功",
      //           type: "success"
      //         });
      //         getListData();
      //       });
    })
    .catch(() => {
      proxy.$message.info("已取消");
    });
}
//点击查询
const handleFilter = () => {
  listQuery.value.pageCurrent = 1;
  getListData();
};
//点击重置
const reset = () => {
  listQuery.value = {
    pageCurrent: 1,
    pageSize: 10
  };
  getListData();
};
// 表格高度计算
const orgHeight = ref();
const tabHeightFn = () => {
  tableHeight.value = window.innerHeight -518;
  orgHeight.value = window.innerHeight - 192;
};
/**
 * pageSize 改变触发
 */
const handleSizeChange = (currentSize) => {
  listQuery.value.pageSize = currentSize;
  getListData();
};

/**
 * 页码改变触发
 */
const handleCurrentChange = (currentPage) => {
  listQuery.value.pageCurrent = currentPage;
  getListData();
};
onMounted(() => {
  // getSysMenuTree();
  getListData();
  tabHeightFn();
  window.onresize = function () {
    tabHeightFn();
  };
  proxy.mittBus.on("mittFn", (data) => {
    keyCount.value = data;
  });
});
</script>
<style lang="scss" scoped>
@import "~@/assets/css/layout.scss";
@import "~@/assets/css/element-plus.scss";
.chart-box {
  height: 280px;
  display: flex;
  justify-content: center;
  align-items: center;
}
.text-box {
  height: 160px;
  display: flex;
  flex-direction: column;
  justify-content: space-between;
}
.text-item {
  width: 140px;
  display: flex;
  justify-content: space-between;
}
.text-color {
  color: rgb(181, 1, 1);
}
</style>
